ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.2 by root, Mon Dec 6 20:53:44 2010 UTC vs.
Revision 1.23 by root, Sat Dec 18 13:58:12 2010 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6PERLVER=5.12.2 # 5.8.9 is also a good choice
7STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
8CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
9EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
10 9
11MKBUNDLE="$STATICPERL/mkbundle"
12
13# perl build variables 10# perl build variables
14PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
13PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments
15PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 17
18ARCH="$(uname -m)" 18ARCH="$(uname -m)"
19 19
20case "$ARCH" in 20case "$ARCH" in
28 ;; 28 ;;
29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 36
37# some configuration options for modules 37# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 38export PERL_MM_USE_DEFAULT=1
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
45 45
46# which extra modules you might want to install 46# which extra modules you might want to install
47EXTRA_MODULES="" 47EXTRA_MODULES=""
48 48
49# overridable functions 49# overridable functions
50preconfigure() { : ; }
50postconfigure() { : ; } 51postconfigure() { : ; }
51postbuild() { : ; } 52postbuild() { : ; }
52postinstall() { : ; } 53postinstall() { : ; }
53 54
54# now source user config, if any 55# now source user config, if any
56if [ "$STATICPERLRC" ]; then
57 . "$STATICPERLRC"
58else
55[ -r /etc/staticperlrc ] && . /etc/staticperlrc 59 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
56[ -r ~/.staticperlrc ] && . ~/.staticperlrc 60 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
57[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 61 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
62fi
58 63
59############################################################################# 64#############################################################################
60# support 65# support
66
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
71export LC_ALL=C # just to be on the safe side
61 72
62# set version in a way that Makefile.PL can extract 73# set version in a way that Makefile.PL can extract
63VERSION=VERSION; eval \ 74VERSION=VERSION; eval \
64$VERSION=0.1 75$VERSION=0.912
65 76
66BZ2=bz2 77BZ2=bz2
67BZIP2=bzip2 78BZIP2=bzip2
68 79
69fatal() { 80fatal() {
102############################################################################# 113#############################################################################
103# clean 114# clean
104 115
105distclean() { 116distclean() {
106 verblock <<EOF 117 verblock <<EOF
107deleting everything installed by this script 118 deleting everything installed by this script (rm -rf $STATICPERL)
108EOF 119EOF
109 120
110 rm -rf "$STATICPERL" 121 rm -rf "$STATICPERL"
111} 122}
112 123
113############################################################################# 124#############################################################################
114# download/configure/compile/install perl 125# download/configure/compile/install perl
115 126
116clean() { 127clean() {
117 cd "$STATICPERL/src/perl-$PERLVER" 2>/dev/null || return 128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
129}
118 130
119 rm -f staticstamp.configure 131realclean() {
120 make distclean >/dev/null 2>&1 132 rm -f "$PERL_PREFIX/staticstamp.postinstall"
133 rm -f "$PERL_PREFIX/staticstamp.install"
134 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
121} 135}
122 136
123fetch() { 137fetch() {
124 rcd "$STATICPERL" 138 rcd "$STATICPERL"
125 139
126 mkdir -p src 140 mkdir -p src
127 rcd src 141 rcd src
128 142
129 if ! [ -d "perl-$PERLVER" ]; then 143 if ! [ -d "perl-$PERL_VERSION" ]; then
130 if ! [ -e "perl-$PERLVER.tar.$BZ2" ]; then 144 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then
131 145
132 URL="$CPAN/src/5.0/perl-$PERLVER.tar.$BZ2" 146 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2"
133 147
134 verblock <<EOF 148 verblock <<EOF
135downloading perl 149downloading perl
136to manually download perl yourself, place 150to manually download perl yourself, place
137perl-$PERLVER.tar.$BZ2 in $STATICPERL 151perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
138trying $URL 152trying $URL
139EOF 153EOF
140 154
141 curl >perl-$PERLVER.tar.$BZ2~ "$URL" \ 155 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
142 || wget -O perl-$PERLVER.tar.$BZ2~ "$URL" \ 156 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
157 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 || fatal "$URL: error during downloading" 158 || fatal "$URL: unable to download"
159 rm -f perl-$PERL_VERSION.tar.$BZ2
144 mv perl-$PERLVER.tar.$BZ2~ perl-$PERLVER.tar.$BZ2 160 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
145 fi 161 fi
146 162
147 verblock <<EOF 163 verblock <<EOF
148unpacking perl 164unpacking perl
149EOF 165EOF
150 166
151 mkdir -p unpack 167 mkdir -p unpack
168 rm -rf unpack/perl-$PERL_VERSION
152 $BZIP2 -d <perl-$PERLVER.tar.bz2 | tar xpC unpack \ 169 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
153 || fatal "perl-$PERLVER.tar.bz2: error during unpacking" 170 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
171 chmod -R u+w unpack/perl-$PERL_VERSION
154 mv unpack/perl-$PERLVER perl-$PERLVER 172 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
155 rmdir -p unpack 173 rmdir -p unpack
156 fi 174 fi
157} 175}
158 176
159# similar to GNU-sed -i or perl -pi 177# similar to GNU-sed -i or perl -pi
160sedreplace() { 178sedreplace() {
161 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 179 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
180 rm -f "$2"
162 mv "$2~" "$2" 181 mv "$2~" "$2"
182}
183
184configure_failure() {
185 cat <<EOF
186
187
188***
189*** Configure failed - see above for the exact error message(s).
190***
191*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
192*** flags are not supported by your compiler. Less often, this is because
193*** PERL_LIBS either contains a library not available on your system (such as
194*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
195***
196*** You can provide your own flags by creating a ~/.staticperlrc file with
197*** variable assignments. For example (these are the actual values used):
198***
199
200PERL_CC="$PERL_CC"
201PERL_CCFLAGS="$PERL_CCFLAGS"
202PERL_OPTIMIZE="$PERL_OPTIMIZE"
203PERL_LDFLAGS="$PERL_LDFLAGS"
204PERL_LIBS="$PERL_LIBS"
205
206EOF
207 exit 1
163} 208}
164 209
165configure() { 210configure() {
166 fetch 211 fetch
167 212
168 rcd "$STATICPERL/src/perl-$PERLVER" 213 rcd "$STATICPERL/src/perl-$PERL_VERSION"
169 214
170 [ -e staticstamp.configure ] && return 215 [ -e staticstamp.configure ] && return
171 216
172 verblock <<EOF 217 verblock <<EOF
173configuring $STATICPERL/src/perl-$PERLVER 218configuring $STATICPERL/src/perl-$PERL_VERSION
174EOF 219EOF
175 220
176 clean
177
178 rm -f "$PREFIX/staticstamp.install" 221 rm -f "$PERL_PREFIX/staticstamp.install"
179 222
223 "$MAKE" distclean >/dev/null 2>&1
224
225 sedreplace '/^#define SITELIB/d' config_h.SH
226
180 # I hate them 227 # I hate them for this
181 grep -q -- -fstack-protector Configure && \ 228 grep -q -- -fstack-protector Configure && \
182 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 229 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
230
231 preconfigure
183 232
184# trace configure \ 233# trace configure \
185 sh Configure -Duselargefiles \ 234 sh Configure -Duselargefiles \
186 -Uuse64bitint \ 235 -Uuse64bitint \
187 -Dusemymalloc=n \ 236 -Dusemymalloc=n \
188 -Uusedl \ 237 -Uusedl \
189 -Uusethreads \ 238 -Uusethreads \
190 -Uuseithreads \ 239 -Uuseithreads \
191 -Uusemultiplicity \ 240 -Uusemultiplicity \
192 -Duseperlio \
193 -Uusesfio \ 241 -Uusesfio \
194 -Uuseshrplib \ 242 -Uuseshrplib \
195 -Dcppflags="$PERL_CPPFLAGS" \ 243 -A ccflags=" $PERL_CCFLAGS" \
196 -Dccflags="-g2 -fno-strict-aliasing" \ 244 -Dcc="$PERL_CC" \
197 -Doptimize="$PERL_OPTIMIZE" \ 245 -Doptimize="$PERL_OPTIMIZE" \
198 -Dldflags="$PERL_LDFLAGS" \ 246 -Dldflags="$PERL_LDFLAGS" \
199 -Dlibs="$PERL_LIBS" \ 247 -Dlibs="$PERL_LIBS" \
200 -Dprefix="$PREFIX" \ 248 -Dprefix="$PERL_PREFIX" \
201 -Dbin="$PREFIX/bin" \ 249 -Dbin="$PERL_PREFIX/bin" \
202 -Dprivlib="$PREFIX/lib" \ 250 -Dprivlib="$PERL_PREFIX/lib" \
203 -Darchlib="$PREFIX/lib" \ 251 -Darchlib="$PERL_PREFIX/lib" \
204 -Uusevendorprefix \ 252 -Uusevendorprefix \
205 -Dsitelib="$PREFIX/lib" \ 253 -Dsitelib="$PERL_PREFIX/lib" \
206 -Dsitearch="$PREFIX/lib" \ 254 -Dsitearch="$PERL_PREFIX/lib" \
207 -Usitelibexp \
208 -Uman1dir \ 255 -Uman1dir \
209 -Uman3dir \ 256 -Uman3dir \
210 -Usiteman1dir \ 257 -Usiteman1dir \
211 -Usiteman3dir \ 258 -Usiteman3dir \
212 -Dpager=/usr/bin/less \ 259 -Dpager=/usr/bin/less \
213 -Demail="$EMAIL" \ 260 -Demail="$EMAIL" \
214 -Dcf_email="$EMAIL" \ 261 -Dcf_email="$EMAIL" \
215 -Dcf_by="$EMAIL" \ 262 -Dcf_by="$EMAIL" \
263 $PERL_CONFIGURE \
264 -Duseperlio \
216 -dE || fatal "Configure failed" 265 -dE || configure_failure
217 266
218 sedreplace ' 267 sedreplace '
219 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 268 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
220 s/ *-fno-stack-protector */ /g 269 s/ *-fno-stack-protector */ /g
221 ' config.sh 270 ' config.sh
228} 277}
229 278
230build() { 279build() {
231 configure 280 configure
232 281
233 rcd "$STATICPERL/src/perl-$PERLVER" 282 rcd "$STATICPERL/src/perl-$PERL_VERSION"
234 283
235 verblock <<EOF 284 verblock <<EOF
236building $STATICPERL/src/perl-$PERLVER 285building $STATICPERL/src/perl-$PERL_VERSION
237EOF 286EOF
238 287
239 rm -f "$PREFIX/staticstamp.install" 288 rm -f "$PERL_PREFIX/staticstamp.install"
240 289
241 make || fatal "make: error while building perl" 290 "$MAKE" || fatal "make: error while building perl"
242 291
243 postbuild || fatal "postbuild hook failed" 292 postbuild || fatal "postbuild hook failed"
244} 293}
245 294
246install() { 295install() {
247 [ -e "$PREFIX/staticstamp.install" ] && return 296 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
248
249 build 297 build
250 298
251 verblock <<EOF 299 verblock <<EOF
252installing $STATICPERL/src/perl-$PERLVER 300installing $STATICPERL/src/perl-$PERL_VERSION
253to $PREFIX 301to $PERL_PREFIX
254EOF 302EOF
255 303
256 rm -rf "$PREFIX" 304 ln -sf "perl/bin/" "$STATICPERL/bin"
257 305 ln -sf "perl/lib/" "$STATICPERL/lib"
306
307 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
308 rm -rf "$PERL_PREFIX" # by this rm -rf
309
258 make install || fatal "make install: error while installing" 310 "$MAKE" install || fatal "make install: error while installing"
259 311
260 rcd "$PREFIX" 312 rcd "$PERL_PREFIX"
261 313
262 # create a "make install" replacement for CPAN 314 # create a "make install" replacement for CPAN
263 cat >"$PREFIX"/bin/cpan-make-install <<EOF 315 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
264make install UNINST=1 316"$MAKE" || exit
317
265if find blib/arch/auto -type f | grep -q -v .exists; then 318if find blib/arch/auto -type f | grep -q -v .exists; then
266 echo Probably an XS module, rebuilding perl 319 echo Probably an XS module, rebuilding perl
267 make perl 320 if "$MAKE" perl; then
321 mv perl "$PERL_PREFIX"/bin/perl~ \
268 rm -f "$PREFIX"/bin/perl 322 && rm -f "$PERL_PREFIX"/bin/perl \
269 make -f Makefile.aperl inst_perl 323 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
270 make -f Makefile.aperl map_clean 324 "$MAKE" -f Makefile.aperl map_clean
325 else
326 "$MAKE" -f Makefile.aperl map_clean
327 exit 1
328 fi
271fi 329fi
330
331"$MAKE" install UNINST=1
272EOF 332EOF
273 chmod 755 "$PREFIX"/bin/cpan-make-install 333 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
274 334
275 # try to trick CPAN into avoiding ~/.cpan completely 335 # trick CPAN into avoiding ~/.cpan completely
276 echo 1 >"$PREFIX/lib/CPAN/MyConfig.pm" 336 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
277 337
278 "$PREFIX"/bin/perl -MCPAN -e ' 338 "$PERL_PREFIX"/bin/perl -MCPAN -e '
279 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 339 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
280 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 340 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
281 CPAN::Shell->o (conf => q<init>); 341 CPAN::Shell->o (conf => q<init>);
282 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
283 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 343 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
284 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 344 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
285 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 345 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
286 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 346 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
287 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PREFIX"'/bin/cpan-make-install"); 347 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
288 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 348 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
289 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 349 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
290 CPAN::Shell->o (conf => q<commit>); 350 CPAN::Shell->o (conf => q<commit>);
291 ' || fatal "error while initialising CPAN" 351 ' || fatal "error while initialising CPAN"
292 352
353 touch "$PERL_PREFIX/staticstamp.install"
354 fi
355
356 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
293 NOCHECK_INSTALL=+ 357 NOCHECK_INSTALL=+
294 instcpan $STATICPERL_MODULES 358 instcpan $STATICPERL_MODULES
295 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 359 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
296 360
297 postinstall || fatal "postinstall hook failed" 361 postinstall || fatal "postinstall hook failed"
298 362
299 touch "$PREFIX/staticstamp.install" 363 touch "$PERL_PREFIX/staticstamp.postinstall"
364 fi
300} 365}
301 366
302############################################################################# 367#############################################################################
303# install a module from CPAN 368# install a module from CPAN
304 369
309installing modules from CPAN 374installing modules from CPAN
310$@ 375$@
311EOF 376EOF
312 377
313 for mod in "$@"; do 378 for mod in "$@"; do
314 "$PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 379 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \
315 || fatal "$mod: unable to install from CPAN" 380 || fatal "$mod: unable to install from CPAN"
316 done 381 done
317 rm -rf "$STATICPERL/build" 382 rm -rf "$STATICPERL/build"
318} 383}
319 384
331 for mod in "$@"; do 396 for mod in "$@"; do
332 echo 397 echo
333 echo $mod 398 echo $mod
334 ( 399 (
335 rcd $mod 400 rcd $mod
336 make -f Makefile.aperl map_clean >/dev/null 2>&1 401 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
337 make distclean >/dev/null 2>&1 402 "$MAKE" distclean >/dev/null 2>&1
338 "$PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 403 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
339 make || fatal "$mod: error building module" 404 "$MAKE" || fatal "$mod: error building module"
340 "$PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 405 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
341 make distclean >/dev/null 2>&1 406 "$MAKE" distclean >/dev/null 2>&1
342 exit 0 407 exit 0
343 ) || exit $? 408 ) || exit $?
344 done 409 done
345} 410}
346 411
347############################################################################# 412#############################################################################
348# do schmorpy stuff
349
350MODSRCDIR=~/src
351
352instmodsrc() {
353 for mod in "$@"; do
354 instmod_src "$MODSRCDIR/$mod"
355 done
356}
357
358install_schmorp() {
359 install
360
361 instcpan Data::Dump Term::ReadLine::Perl Term::ANSIColor Term::ReadKey
362 instcpan Digest::SHA Digest::MD6 Digest::SHA256 Digest::MD4 Digest::HMAC_MD5 Digest::HMAC_MD6 Digest::FNV
363 #instcpan Net::SSLeay # requires static -ldl
364
365 instmodsrc common-sense Crypt-Twofish2 Array-Heap Convert-Scalar Compress-LZF JSON-XS
366 instmodsrc EV Guard Async-Interrupt IO-AIO
367 instmodsrc AnyEvent AnyEvent-AIO Coro AnyEvent-HTTP
368 instmodsrc Linux-Inotify2 EV-Loop-Async
369
370 instcpan AnyEvent::HTTPD
371}
372
373#############################################################################
374# main 413# main
375 414
376podusage() { 415podusage() {
377 echo 416 echo
417
378 if [ -e "$PREFIX/bin/perl" ]; then 418 if [ -e "$PERL_PREFIX/bin/perl" ]; then
379 "$PREFIX/bin/perl" -MPod::Usage -e \ 419 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
380 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 420 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
381 2>/dev/null && exit 421 2>/dev/null && exit
382 fi 422 fi
423
383 # try whatever perl we can find 424 # try whatever perl we can find
384 perl -MPod::Usage -e \ 425 perl -MPod::Usage -e \
385 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 426 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
386 2>/dev/null && exit 427 2>/dev/null && exit
387 428
388 fatal "displaying documentation requires a working perl - try '$0 install' first" 429 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
389} 430}
390 431
391usage() { 432usage() {
392 podusage 0 433 podusage 0
393} 434}
394 435
395catmkbundle() { 436catmkbundle() {
396 { 437 {
397 read dummy 438 read dummy
398 echo "#!$PREFIX/bin/perl" 439 echo "#!$PERL_PREFIX/bin/perl"
399 cat 440 cat
400 } <<'MKBUNDLE' 441 } <<'MKBUNDLE'
401#CAT mkbundle 442#CAT mkbundle
402MKBUNDLE 443MKBUNDLE
403} 444}
404 445
405bundle() { 446bundle() {
406 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 447 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
407 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 448 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
449 CACHE="$STATICPERL/cache"
450 mkdir -p "$CACHE"
408 "$PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 451 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
409} 452}
410 453
411if [ $# -gt 0 ]; then 454if [ $# -gt 0 ]; then
412 while [ $# -gt 0 ]; do 455 while [ $# -gt 0 ]; do
413 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 456 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
414 mkdir -p "$PREFIX" || fatal "$PREFIX: cannot create" 457 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
415 458
416 command="${1#--}"; shift 459 command="${1#--}"; shift
417 case "$command" in 460 case "$command" in
461 version )
462 echo "staticperl version $VERSION"
463 ;;
418 fetch | configure | build | install | clean | distclean) 464 fetch | configure | build | install | clean | realclean | distclean)
419 verblock <<EOF
420$command
421EOF
422 "$command" 465 ( "$command" ) || exit
423 ;; 466 ;;
424 instsrc ) 467 instsrc )
425 instsrc "$@" 468 ( instsrc "$@" ) || exit
426 exit 469 exit
427 ;; 470 ;;
428 instcpan ) 471 instcpan )
429 instcpan "$@" 472 ( instcpan "$@" ) || exit
430 exit 473 exit
431 ;; 474 ;;
432 instschmorp )
433 install_schmorp
434 ;;
435 cpan ) 475 cpan )
436 install 476 ( install ) || exit
437 "$PREFIX/bin/cpan" "$@" 477 "$PERL_PREFIX/bin/cpan" "$@"
438 exit 478 exit
439 ;; 479 ;;
440 mkbundle ) 480 mkbundle )
441 install 481 ( install ) || exit
442 bundle "$@" 482 bundle "$@"
443 exit 483 exit
444 ;; 484 ;;
445 mkperl ) 485 mkperl )
446 install 486 ( install ) || exit
447 bundle --perl "$@" 487 bundle --perl "$@"
488 exit
489 ;;
490 mkapp )
491 ( install ) || exit
492 bundle --app "$@"
448 exit 493 exit
449 ;; 494 ;;
450 help ) 495 help )
451 podusage 2 496 podusage 2
452 ;; 497 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines